﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace prohlizec
{
    public partial class Form1 : Form
    {
        public String directory;
        String[] directories;
        public Form1()
        {
            InitializeComponent();
            listView.Dock = DockStyle.None;
            directory = Directory.GetCurrentDirectory();
            listView.Columns.Add("Pojmenovani",
                           -2,
                           HorizontalAlignment.Left);
            listView.Columns.Add("Sirka",
                           -2,
                           HorizontalAlignment.Right);
            listView.Columns.Add("Obmeneno naposledy",
                           -2,
                           HorizontalAlignment.Left);
            PopulateListView();
            this.Controls.Add(listView);
            comboBox1.Text = directory;
        }

        private void listView_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*ListView.SelectedListViewItemCollection
                    selectedItems = listView.SelectedItems;

            StringBuilder sb = new StringBuilder(1024);
            sb.Append("You selected the following item(s).\n");

            int count = selectedItems.Count;
            for (int i = 0; i < count; i++)
            {
                sb.Append("\t").Append(selectedItems[i].Text)
                                         .Append("\n");
            }
            MessageBox.Show(sb.ToString());*/
            ListView.SelectedListViewItemCollection selectedItems = listView.SelectedItems;
            selectedItems = listView.SelectedItems;
            int count = selectedItems.Count;
            // Uzivatel si vybere jenom jeden obrazek.
            // Jo a taky si nebude prohlizet root disku.
            // Rekl to Martin Bursik.
            // Nemuzete dokazat ze ne.
            if (count < 1) return;
            String it = selectedItems[0].Text;
            if (it == "..")
            {
                //directory = Path.GetPathRoot(directory);// orizni adresar

                if (directory.ToCharArray()[directory.Length - 1] == '\\')
                {
                    //MessageBox.Show("Trim \\");
                    directory.Remove(directory.Length - 2);
                }
                directory = directory.Remove(directory.LastIndexOf('\\'));
                if (directory.Length == 2) directory += "\\";
                
                listUpdate();
                return;
            }
            // co kdyz se tenhle clovek rozhod' klidnout na adresar?
            for (int i = 0; i < directories.Length; i++)
            {
                if (Path.GetFileName(directories[i]) == it)
                {
                    directory = directories[i];
                    listUpdate();
                    return;
                }
            }
            // a tohle uz znamena trable...
            //MessageBox.Show("Tohle se NESMI!");
            //MessageBox.Show("[zde vlozte obrazek]");

            fullscreenform form=new fullscreenform(directory+"\\"+selectedItems[0].Text);
            form.Show();
            
        }

        private void listUpdate()
        {
            //if (directory.ToCharArray()[directory.Length - 1] != '\\') directory += "\\";
            listView.Items.Clear();
            PopulateListView();
            comboBox1.Text = directory;
        }

        private void PopulateListView() {
          // Set the view to show details.
            listView.View = View.Tile;
            listView.TileSize = new Size(200, 70);
          ImageList imageList = new ImageList();
          imageList.ImageSize = new Size(64, 64);
            imageList.Images.Add(
                        Bitmap.FromFile("./images/Folder.gif")
                          );
 

          this.Text = directory;
          ListViewItem item;

          // Ted pridat jeste "O adresar nahoru"

          item = new ListViewItem("..", 0);
          item.SubItems.Add("");
          item.SubItems.Add("");
          listView.Items.Add(item);

          directories = 
                   Directory.GetDirectories(directory);
          int length = directories.Length;
          for (int i=0; i<length; i++) {
            item = new ListViewItem(Path.GetFileName(directories[i]),0);
            item.SubItems.Add("");
            item.SubItems.Add(
                Directory.GetLastAccessTime(directories[i]).ToString()
                       );
            listView.Items.Add(item);
          }

          String[] files = Directory.GetFiles(directory);
          length = files.Length;
          for (int i=0; i<length; i++) {
              // Musi to byt jepegecko.
              if (Path.GetExtension(files[i]) != ".jpg" && Path.GetExtension(files[i]) != ".jpeg") continue;

              //-------------
              Bitmap thumb=new Bitmap(files[i]);
              //Bitmap pthumb=
              float pomer_stran = (float)thumb.Width / (float)thumb.Height;
              int thumbx =(int) ( (thumb.Width > thumb.Height) ? (64.0f) : (64.0f * pomer_stran) );
              int thumby =(int) ( (thumb.Height > thumb.Width) ? (64.0f) : (64.0f / pomer_stran) );
              Bitmap realt = new Bitmap(64, 64);
              Graphics g = Graphics.FromImage(realt);
              g.DrawImage(thumb, new Rectangle((64 - thumbx) / 2, (64 - thumby) / 2, thumbx, thumby));
              //MessageBox.Show("" + thumb.Width + ";" + thumb.Height + "->" + thumbx + ";" + thumby);
              imageList.Images.Add(realt);
              //-------------
              
              item = new ListViewItem(Path.GetFileName(files[i]), i+1);



            FileInfo fi = new FileInfo(files[i]);
            item.SubItems.Add(Convert.ToString(fi.Length));
            item.SubItems.Add(
                      File.GetLastWriteTime(files[i]).ToString()
                       );
            listView.Items.Add(item);
          }


          listView.LargeImageList = imageList;

      }

        private void comboBox1_Changed(object sender, EventArgs e)
        {
            // Mozna by to mohlo neco lepsiho udelat...
        }

        private void button1_Click(object sender, EventArgs e)
        {
            directory = comboBox1.Text;
            listUpdate();
        }
}

}
